/* Copyright (c) 2014 All Rights Reserved, http://www.apiomat.com/
 *
 * This source is property of apiomat.com. You are not allowed to use or distribute this code without a contract
 * explicitly giving you these permissions. Usage of this code includes but is not limited to running it on a server or
 * copying parts from it.
 *
 * Apinauten GmbH, Hainstrasse 10a, 04109 Leipzig, Germany
 *
 * 03.02.2015
 * phimi */
package com.apiomat.backend.management;

/**
 * @author phimi
 */
public interface IModuleTaskListener
{
	enum TaskType
	{
		REGISTER,
		UNREGISTER,
		REREGISTER,
		ROLLBACK
	}

	/**
	 * Method is called when task begin to run
	 *
	 * @param type type of task
	 * @param jobId internal ID of this task
	 * @param moduleName name of the module
	 * @param usedSystem system on that task run
	 */
	public void taskBegin( final TaskType type, final String jobId, final String moduleName, final String usedSystem );

	/**
	 * Method is called when task ends
	 *
	 * @param type type of task
	 * @param jobId internal ID of this task
	 * @param moduleName name of the module
	 * @param usedSystem system on that task is executed
	 */
	public void taskEnd( final TaskType type, final String jobId, final String moduleName, final String usedSystem );
}
